--
--@author Ragman2414
--

CruiseControlAxis = {}


function CruiseControlAxis.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Enterable, specializations) and SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function CruiseControlAxis.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onLoad", CruiseControlAxis);
    SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", CruiseControlAxis);
    SpecializationUtil.registerEventListener(vehicleType, "onEnterVehicle", CruiseControlAxis);
end;

function CruiseControlAxis:onLoad()
    self.cruiseControlAxisEvents = {};
    self.cruiseControlAxisEventsIds = {};
    --self.cruiseControlIsActivated = false;
    self.lastInput = nil;
end;

function CruiseControlAxis:onEnterVehicle()
    self.lastInput = nil;
    self.lastCruiseSpeed = 120;
end
function CruiseControlAxis:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection)
    if self.isClient then
        self:clearActionEventsTable(self.cruiseControlAxisEvents);
        self.cruiseControlAxisEventsIds = {};
        if isActiveForInputIgnoreSelection then
            --self.cruiseControlAxisEvents, 'ragman_CC_activate', self, CruiseControlAxis.activateCruiseControl,  triggerKeyUp, triggerKeyDown, triggerAlways, isActive, nil
            --local _, actionEventId1 = self:addActionEvent(self.cruiseControlAxisEvents, 'ragman_CC_activate', self, CruiseControlAxis.activateCruiseControl, false, true, false, true, nil);
            --g_inputBinding:setActionEventTextVisibility(actionEventId1, true);
            --g_inputBinding:setActionEventTextPriority(actionEventId1, GS_PRIO_HIGH);
            --table.insert(self.cruiseControlAxisEventsIds, actionEventId1);


            local actionEvent, actionEventId = self:addActionEvent(self.cruiseControlAxisEvents, 'ragman_CC', self, CruiseControlAxis.setCruiseControl, false, false, true, true, nil);
            g_inputBinding:setActionEventTextVisibility(actionEventId, true);
            g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH);
            table.insert(self.cruiseControlAxisEventsIds, actionEventId);
        end;
    end;
end;

function CruiseControlAxis.activateCruiseControl(self)
--    if  g_cruiseControlAxis.isActive then
--        g_cruiseControlAxis.isActive = false
--    else
--        g_cruiseControlAxis.isActive = true
--    end
end

function CruiseControlAxis.setCruiseControl(self, actionName, inputValue)
    --if  g_cruiseControlAxis.isActive then

        if(self.lastCruiseSpeed == nil) then
            self.lastCruiseSpeed = 120;
        end
        if(self.lastInput == nil or self.lastInput == inputValue) then

            self.lastInput = inputValue;
            return;
        end
        inputValue = ( inputValue +1) /2
        local cruiseSpeed = math.floor(inputValue * self.spec_drivable.cruiseControl.maxSpeed)
        cruiseSpeed = math.max(1, math.min(cruiseSpeed,self.spec_drivable.cruiseControl.maxSpeed))
        if(self.lastCruiseSpeed ~= cruiseSpeed) then
            self.spec_drivable.cruiseControl.speed = cruiseSpeed;
            if g_server ~= nil then
                g_server:broadcastEvent(SetCruiseControlSpeedEvent.new(self, cruiseSpeed, self.spec_drivable.cruiseControl.speedReverse), nil, nil, self)
            else
                g_client:getServerConnection():sendEvent(SetCruiseControlSpeedEvent.new(self, cruiseSpeed, self.spec_drivable.cruiseControl.speedReverse))
            end
            self.lastInput = inputValue;
            self.lastCruiseSpeed = cruiseSpeed;
        end

    --end
end
